# react-native-maps-navigation-v

Enhances React Native Maps with Realtime Navigation.

`Please note that before using this package you'll have to install`

## [react-native-maps](https://github.com/react-native-maps/react-native-maps).

Some properties and/or component names might change without notice.

![alt text]( docs/preview.gif "react-native-maps-navigation-next")

## Installation

**React Native >= 0.49**

```bash
npm i react-native-maps-navigation-v
```

## Example

[Head over to the example application to get started right away.](https://github.com/flyandi/react-native-maps-navigation-example)

The example application uses most components and api modules of this library and gets you started in a useful direction.

## Components

The library exposes the following modules and components.

The main component is `MapViewNavigation`:

[`<MapViewNavigation />` Component API](docs/MapViewNavigation.md)

The library also ships with various UI components:

[`<DirectionInputBox />` Component API](docs/DirectionInputBox.md)

[`<DirectionsListView />` Component API](docs/DirectionsListView.md)

[`<DurationDistanceLabel />` Component API](docs/DurationDistanceLabel.md)

[`<DurationDistanceView />` Component API](docs/DurationDistanceView.md)

[`<ManeuverView />` Component API](docs/ManeuverView.md)

[`<ManeuverLabel />` Component API](docs/ManeuverLabel.md)

[`<TravelModeBox />` Component API](docs/TravelModeBox.md)

These are internal components used by the library:

[`<ManeuverArrow />` Component API](docs/ManeuverArrow.md)

[`<CloseButton />` Component API](docs/CloseButton.md)

[`<PositionMarker />` Component API](docs/PositionMarker.md)

[`<RouteMarker />` Component API](docs/RouteMarker.md)

[`<RouterPolyline />` Component API](docs/RouterPolyline.md)

## General Usage




