// src/comp/CloseButton/index.tsx
import { Component } from "react";
import { StyleSheet, Text, TouchableOpacity } from "react-native";

// src/const/NavigationIcons.ts
var NavigationIconsFont = {
  fontFamily: "Navigation"
};
var Icons = {
  watch: "\uE957",
  timer3: "\uE958",
  timer10: "\uE959",
  timerAv: "\uE95A",
  timer: "\uE95B",
  menu: "\uE95C",
  zoomOutMap: "\uE95D",
  zoomOut: "\uE95E",
  zoomIn: "\uE95F",
  linearScale: "\uE960",
  room: "\uE961",
  place: "\uE961",
  zoomOutMap2: "\uE962",
  locationOff: "\uE963",
  locationCity: "\uE964",
  locationDisabled: "\uE965",
  locationSearching: "\uE966",
  myLocation: "\uE967",
  editLocation: "\uE968",
  addLocation: "\uE969",
  map: "\uE96A",
  directionsTransit: "\uE96B",
  directionsWalk: "\uE96C",
  directionsBike: "\uE96D",
  cardTravel: "\uE96E",
  home: "\uE96F",
  directionsDriving: "\uE970",
  navigate: "\uE975",
  target: "\uE971",
  location2: "\uE972",
  location3: "\uE973",
  compassDirection: "\uE974",
  compassDot: "\uE977",
  arriveLeft: "\uE900",
  arriveRight: "\uE901",
  arriveStraight: "\uE902",
  arrive: "\uE903",
  close: "\uE904",
  continueLeft: "\uE905",
  continueRight: "\uE906",
  continueSlightLeft: "\uE907",
  continueSlightRight: "\uE908",
  continueStraight: "\uE909",
  continueUturn: "\uE90A",
  continue: "\uE90B",
  keepLeft: "\uE907",
  keepRight: "\uE908",
  departLeft: "\uE90C",
  departRight: "\uE90D",
  departStraight: "\uE90E",
  depart: "\uE90F",
  endOfRoadLeft: "\uE910",
  endOfRoadRight: "\uE911",
  flag: "\uE912",
  forkLeft: "\uE913",
  forkRight: "\uE914",
  forkSlightLeft: "\uE915",
  forkSlightRight: "\uE916",
  forkStraight: "\uE917",
  fork: "\uE918",
  invalidLeft: "\uE919",
  invalidRight: "\uE91A",
  invalidSlightLeft: "\uE91B",
  invalidSlightRight: "\uE91C",
  invalidStraight: "\uE91D",
  invalidUturn: "\uE91E",
  invalid: "\uE91F",
  straight: "\uE91F",
  merge: "\uE976",
  mergeLeft: "\uE920",
  mergeRight: "\uE921",
  mergeSlightLeft: "\uE922",
  mergeSlightRight: "\uE923",
  mergeStraight: "\uE924",
  newNameLeft: "\uE925",
  newNameRight: "\uE926",
  newNameSharpLeft: "\uE927",
  newNameSharpRight: "\uE928",
  newNameSlightLeft: "\uE929",
  newNameSlightRight: "\uE92A",
  newNameStraight: "\uE92B",
  notificaitonSharpRight: "\uE92C",
  notificationLeft: "\uE92D",
  notificationRight: "\uE92E",
  notificationSharpLeft: "\uE92F",
  notificationSlightLeft: "\uE930",
  notificationSlightRight: "\uE931",
  notificationStraight: "\uE932",
  offRampLeft: "\uE933",
  offRampRight: "\uE934",
  offRampSlightLeft: "\uE935",
  offRampSlightRight: "\uE936",
  rampLeft: "\uE933",
  rampRight: "\uE934",
  rampSlightLeft: "\uE935",
  rampSlightRight: "\uE936",
  onRampLeft: "\uE937",
  onRampRight: "\uE938",
  onRampSharpLeft: "\uE939",
  onRampSharpRight: "\uE93A",
  onRampSlightLeft: "\uE93B",
  onRampSlightRight: "\uE93C",
  onRampStraight: "\uE93D",
  rotaryLeft: "\uE93E",
  rotaryRight: "\uE93F",
  rotarySharpLeft: "\uE940",
  rotarySharpRight: "\uE941",
  rotarySlightLeft: "\uE942",
  rotarySlightRight: "\uE943",
  rotaryStraight: "\uE944",
  rotary: "\uE945",
  roundaboutLeft: "\uE946",
  roundaboutRight: "\uE947",
  roundaboutSharpLeft: "\uE948",
  roundaboutSharpRight: "\uE949",
  roundaboutSlightLeft: "\uE94A",
  roundaboutSlightRight: "\uE94B",
  roundaboutStraight: "\uE94C",
  roundabout: "\uE94D",
  turnLeft: "\uE94E",
  turnRight: "\uE94F",
  turnSharpLeft: "\uE950",
  turnSharpRight: "\uE951",
  turnSlightLeft: "\uE952",
  turnSlightRight: "\uE953",
  turnStraight: "\uE954",
  updown: "\uE955"
};
var NavigationIcons_default = Icons;

// src/comp/CloseButton/index.tsx
import { jsx } from "react/jsx-runtime";
var defaultProps = {
  maneuver: void 0,
  size: 25,
  opacity: 1,
  color: "#000000",
  onPress: () => {
  }
};
var CloseButton = class extends Component {
  static defaultProps = defaultProps;
  constructor(props) {
    super(props);
  }
  render() {
    const styles = this.createStyles(this.props);
    return /* @__PURE__ */ jsx(TouchableOpacity, { onPress: this.props.onPress, children: /* @__PURE__ */ jsx(Text, { style: styles.closeButtonText, children: NavigationIcons_default.close }) });
  }
  createStyles(props) {
    return StyleSheet.create({
      closeButtonText: {
        fontSize: props.size,
        opacity: props.opacity,
        color: props.color
      }
    });
  }
};

// src/comp/DirectionsListView/index.tsx
import { Component as Component6 } from "react";
import { ScrollView, StyleSheet as StyleSheet6, Text as Text5, View as View3 } from "react-native";

// src/comp/DirectionsListView/item.tsx
import { Component as Component5 } from "react";
import { View as View2 } from "react-native";

// src/comp/DirectionsListView/styles.ts
import { StyleSheet as StyleSheet2 } from "react-native";
var styles_default = () => StyleSheet2.create({
  directionDetailHeader: {
    padding: 25,
    paddingBottom: 10,
    backgroundColor: "#f7f7f4",
    flexDirection: "column"
  },
  directionDetailHeaderSection: {
    marginBottom: 15,
    flexDirection: "column"
  },
  directionDetailHeaderAddressText: {
    fontSize: 16,
    ...NavigationIconsFont
  },
  directionDetailHeaderAddressLabel: {
    fontSize: 13,
    opacity: 0.7,
    fontWeight: "bold",
    ...NavigationIconsFont
  },
  directionDetailTravel: {
    margin: 25
  },
  directionDetailTravelDuration: {
    fontSize: 32,
    color: "#387bc1",
    ...NavigationIconsFont
  },
  directionDetailTravelDistance: {
    fontSize: 22,
    opacity: 0.8,
    ...NavigationIconsFont
  },
  bold: {
    fontWeight: "bold",
    fontSize: 16,
    flexWrap: "wrap",
    ...NavigationIconsFont
  },
  regular: {
    fontSize: 16,
    flexWrap: "wrap",
    ...NavigationIconsFont
  },
  extra: {
    fontSize: 13,
    flexWrap: "wrap",
    color: "#387bc1",
    ...NavigationIconsFont
  },
  durationDistance: {
    fontSize: 14,
    opacity: 0.8,
    flexWrap: "wrap",
    ...NavigationIconsFont
  },
  directionDetailSectionContainer: {
    margin: 25,
    marginTop: 0,
    flex: 1
  },
  directionDetailSection: {
    borderColor: "#e6e6e6",
    borderTopWidth: 1,
    paddingTop: 20,
    marginBottom: 20,
    flexDirection: "row",
    flex: 1
  },
  directionDetailIconContainer: {
    width: 50,
    flex: 0,
    justifyContent: "flex-start",
    alignItems: "center"
  },
  directionDetailContent: {
    flexDirection: "column",
    flex: 1
  }
});

// src/comp/ManeuverArrow/index.tsx
import { Component as Component2 } from "react";
import { Text as Text2 } from "react-native";

// src/comp/ManeuverArrow/styles.ts
import { StyleSheet as StyleSheet3 } from "react-native";
var styles_default2 = (props) => StyleSheet3.create({
  maneuverArrow: {
    fontSize: props.size,
    color: props.color,
    opacity: props.opacity,
    textAlign: "center",
    ...NavigationIconsFont
  }
});

// src/const/DirectionTypes.ts
var DEFAULT_DIRECTION_TYPE = "invalid";
var DirectionTypes_default = {
  NORTH: "NORTH",
  NORTHEAST: "NORTHEAST",
  EAST: "EAST",
  SOUTHEAST: "SOUTHEAST",
  SOUTH: "SOUTH",
  SOUTHWEST: "SOUTHWEST",
  WEST: "WEST",
  NORTHWEST: "NORTHWEST"
};

// src/comp/ManeuverArrow/index.tsx
import { jsx as jsx2 } from "react/jsx-runtime";
var ManeuverArrow = class extends Component2 {
  static defaultProps = {
    maneuver: void 0,
    size: 25,
    opacity: 1,
    color: "#000000"
  };
  constructor(props) {
    super(props);
  }
  render() {
    var _a;
    const styles = styles_default2(this.props);
    const icon = ((_a = this.props.maneuver) == null ? void 0 : _a.name) || DEFAULT_DIRECTION_TYPE;
    return /* @__PURE__ */ jsx2(Text2, { style: styles.maneuverArrow, children: NavigationIcons_default[icon] });
  }
};

// src/comp/ManeuverLabel/index.tsx
import { Component as Component3 } from "react";
import { View, Text as Text3 } from "react-native";

// src/comp/ManeuverLabel/styles.ts
import { StyleSheet as StyleSheet4 } from "react-native";
var styles_default3 = (props) => StyleSheet4.create({
  maneuverLabel: {
    flexDirection: "row"
  },
  bold: {
    fontWeight: "bold",
    fontSize: props.fontSize,
    flexWrap: "wrap",
    color: props.color,
    ...NavigationIconsFont
  },
  regular: {
    fontSize: props.fontSize,
    flexWrap: "wrap",
    color: props.color,
    ...NavigationIconsFont
  },
  extra: {
    fontSize: props.fontSize * 0.8,
    flexWrap: "wrap",
    color: "#387bc1",
    marginTop: 4,
    ...NavigationIconsFont
  },
  durationDistance: {
    fontSize: props.fontSize * 0.8,
    opacity: 0.8,
    flexWrap: "wrap",
    ...NavigationIconsFont
  }
});

// src/comp/ManeuverLabel/index.tsx
import { jsx as jsx3, jsxs } from "react/jsx-runtime";
var ManeuverLabel = class extends Component3 {
  static defaultProps = {
    instructions: "",
    fontFamily: void 0,
    fontFamilyBold: void 0,
    fontSize: 15,
    fontColor: void 0
  };
  constructor(props) {
    super(props);
  }
  getParsedInstructions(styles) {
    const parts = [];
    const regex = /(\w+)|<(.*?)>(.*?)<\/.*?>/g;
    const mapping = {
      r: styles.regular,
      b: styles.bold,
      d: styles.durationDistance,
      div: styles.extra
    };
    let m;
    let last = false;
    while (m = regex.exec(this.props.instructions || "")) {
      if (m.index === regex.lastIndex) {
        regex.lastIndex++;
        last = true;
      }
      if (m[2]) {
        let tag = m[2].split(" ")[0];
        if (tag === "div") m[3] = "\n" + m[3];
        parts.push(/* @__PURE__ */ jsxs(Text3, { style: mapping[tag], children: [
          m[3],
          last ? "." : " "
        ] }, m.index));
      } else {
        parts.push(/* @__PURE__ */ jsxs(Text3, { style: mapping.r, children: [
          m[0],
          last ? "." : " "
        ] }, m.index));
      }
    }
    return /* @__PURE__ */ jsx3(Text3, { style: { flexWrap: "wrap", color: this.props.fontColor || "red" }, children: parts });
  }
  render() {
    const styles = styles_default3(this.props);
    return /* @__PURE__ */ jsx3(View, { style: styles.maneuverLabel, children: this.getParsedInstructions(styles) });
  }
};

// src/comp/DurationDistanceLabel/index.tsx
import { Component as Component4 } from "react";
import { Text as Text4 } from "react-native";

// src/comp/DurationDistanceLabel/styles.ts
import { StyleSheet as StyleSheet5 } from "react-native";
var styles_default4 = (props) => StyleSheet5.create({
  durationDistanceText: {
    fontFamily: props.fontFamily,
    fontSize: props.fontSize * 0.8,
    opacity: props.opacity,
    flexWrap: "wrap"
  },
  durationDistanceTravelModeIcon: {
    ...NavigationIconsFont,
    fontSize: props.fontSize * 0.8,
    opacity: props.opacity,
    marginRight: 8
  }
});

// src/const/TravelModes.ts
var DRIVING = "DRIVING";
var WALKING = "WALKING";
var TRANSIT = "TRANSIT";
var BICYCLING = "BICYCLING";
var MODE_MAPPING = {
  [DRIVING]: {
    mode: DRIVING,
    name: "Driving",
    icon: NavigationIcons_default.directionsDriving
  },
  [WALKING]: {
    mode: WALKING,
    name: "Walking",
    icon: NavigationIcons_default.directionsWalk
  },
  [TRANSIT]: {
    mode: TRANSIT,
    name: "Transit",
    icon: NavigationIcons_default.directionsTransit
  },
  [BICYCLING]: {
    mode: BICYCLING,
    name: "Bicycling",
    icon: NavigationIcons_default.directionsBike
  }
};
var DEFAULT_MODES = [DRIVING, WALKING, TRANSIT, BICYCLING];
var TravelModes_default = { DRIVING, WALKING, TRANSIT, BICYCLING };

// src/comp/DurationDistanceLabel/index.tsx
import { jsxs as jsxs2 } from "react/jsx-runtime";
var DurationDistanceLabel = class extends Component4 {
  static defaultProps = {
    style: {},
    fontFamily: void 0,
    fontSize: 16,
    distance: void 0,
    duration: void 0,
    opacity: 0.8,
    withTravelModeIcon: false
  };
  constructor(props) {
    super(props);
  }
  render() {
    const styles = styles_default4(this.props);
    const travelMode = MODE_MAPPING[this.props.mode];
    return /* @__PURE__ */ jsxs2(Text4, { style: [styles.durationDistanceText, this.props.style], children: [
      !this.props.withTravelModeIcon || !travelMode ? null : /* @__PURE__ */ jsxs2(Text4, { style: styles.durationDistanceTravelModeIcon, children: [
        travelMode.icon,
        " "
      ] }),
      this.props.distance ? this.props.distance.text : "",
      this.props.duration ? `  (${this.props.duration.text})` : ""
    ] });
  }
};

// src/comp/DirectionsListView/item.tsx
import { jsx as jsx4, jsxs as jsxs3 } from "react/jsx-runtime";
var defaultProps2 = {
  instructions: "",
  fontFamily: void 0,
  fontFamilyBold: void 0,
  distance: void 0,
  duration: void 0,
  maneuver: void 0,
  fontSize: void 0,
  displayTravelMode: false
};
var DirectionListViewItem = class extends Component5 {
  static defaultProps = defaultProps2;
  constructor(props) {
    super(props);
  }
  render() {
    const styles = this.createStyles(this.props);
    return /* @__PURE__ */ jsxs3(View2, { style: styles.directionDetailSection, children: [
      /* @__PURE__ */ jsx4(View2, { style: styles.directionDetailIconContainer, children: /* @__PURE__ */ jsx4(
        ManeuverArrow,
        {
          ...this.props,
          size: 24
        }
      ) }),
      /* @__PURE__ */ jsxs3(View2, { style: styles.directionDetailContent, children: [
        /* @__PURE__ */ jsx4(
          ManeuverLabel,
          {
            ...this.props
          }
        ),
        /* @__PURE__ */ jsx4(
          DurationDistanceLabel,
          {
            ...this.props,
            style: { marginTop: 4 },
            withTravelModeIcon: this.props.displayTravelMode
          }
        )
      ] })
    ] });
  }
  createStyles(props) {
    return styles_default();
  }
};

// src/comp/DirectionsListView/index.tsx
import { jsx as jsx5, jsxs as jsxs4 } from "react/jsx-runtime";
var defaultProps3 = {
  fontFamily: void 0,
  fontFamilyBold: void 0,
  showOriginDestinationHeader: true,
  displayTravelMode: false
};
var DirectionsListView = class extends Component6 {
  static defaultProps = defaultProps3;
  constructor(props) {
    super(props);
  }
  render() {
    const { route, showOriginDestinationHeader } = this.props;
    if (!route || !Array.isArray(route.steps)) {
      return null;
    }
    const styles = this.createStyles(this.props);
    return /* @__PURE__ */ jsxs4(ScrollView, { children: [
      /* @__PURE__ */ jsxs4(View3, { style: styles.directionDetailTravel, children: [
        /* @__PURE__ */ jsx5(Text5, { style: styles.directionDetailTravelDuration, children: route.duration.text }),
        /* @__PURE__ */ jsx5(Text5, { style: styles.directionDetailTravelDistance, children: route.distance.text })
      ] }),
      /* @__PURE__ */ jsx5(View3, { style: styles.directionDetailSectionContainer, children: route.steps.map((step) => /* @__PURE__ */ jsx5(DirectionListViewItem, { ...this.props, ...step })) })
    ] });
  }
  createStyles(props) {
    return StyleSheet6.create({
      directionDetailHeader: {
        // Add your styles here
      },
      directionDetailHeaderSection: {
        // Add your styles here
      },
      directionDetailHeaderAddressLabel: {
        // Add your styles here
      },
      directionDetailHeaderAddressText: {
        // Add your styles here
      },
      directionDetailTravel: {
        // Add your styles here
      },
      directionDetailTravelDuration: {
        // Add your styles here
      },
      directionDetailTravelDistance: {
        // Add your styles here
      },
      directionDetailSectionContainer: {
        // Add your styles here
      }
    });
  }
};

// src/comp/DurationDistanceView/index.tsx
import { Component as Component7 } from "react";
import { Text as Text6, TouchableOpacity as TouchableOpacity2, View as View4 } from "react-native";

// src/comp/DurationDistanceView/styles.ts
import { StyleSheet as StyleSheet7 } from "react-native";
var styles_default5 = (props) => StyleSheet7.create({
  durationDistanceView: {
    padding: 15,
    backgroundColor: "#f7f7f4",
    flexDirection: "row",
    minHeight: 120,
    alignItems: "center"
  },
  durationDistanceContent: {
    flex: 1
  },
  durationDistanceClose: {
    flex: 0,
    width: 30,
    justifyContent: "flex-end",
    alignItems: "flex-end"
  }
});

// src/comp/DurationDistanceView/index.tsx
import { jsx as jsx6, jsxs as jsxs5 } from "react/jsx-runtime";
var DurationDistanceView = class extends Component7 {
  static defaultProps = {
    step: void 0,
    fontFamily: void 0,
    fontFamilyBold: void 0,
    fontSize: 20,
    arrowSize: 50,
    arrowColor: "#545455",
    withCloseButton: false,
    onClose: void 0,
    onPress: void 0
  };
  constructor(props) {
    super(props);
  }
  render() {
    const styles = styles_default5(this.props);
    const step = this.props.step;
    if (!step) return null;
    return /* @__PURE__ */ jsxs5(TouchableOpacity2, { style: styles.durationDistanceView, onPress: this.props.onPress, children: [
      /* @__PURE__ */ jsxs5(View4, { style: styles.durationDistanceContent, children: [
        /* @__PURE__ */ jsx6(Text6, { children: step.distance ? step.distance.text : "" }),
        /* @__PURE__ */ jsx6(Text6, { children: step.duration ? step.duration.text : "" })
      ] }),
      !this.props.withCloseButton ? null : /* @__PURE__ */ jsx6(View4, { style: styles.durationDistanceClose, children: /* @__PURE__ */ jsx6(CloseButton, { onPress: () => this.props.onClose && this.props.onClose() }) })
    ] });
  }
};

// src/comp/ManeuverView/index.tsx
import { Component as Component8 } from "react";
import { TouchableOpacity as TouchableOpacity3, View as View5 } from "react-native";

// src/comp/ManeuverView/styles.ts
import { StyleSheet as StyleSheet8 } from "react-native";
var styles_default6 = (props) => StyleSheet8.create({
  maneuverView: {
    padding: 15,
    backgroundColor: props.backgroundColor,
    flexDirection: "row",
    minHeight: 120,
    alignItems: "center"
  },
  maneuverViewArrow: {
    flex: 0,
    width: 80,
    justifyContent: "center",
    alignItems: "center"
  },
  maneuverViewDirection: {
    flex: 1
  },
  maneuverClose: {
    flex: 0,
    width: 30,
    justifyContent: "flex-end",
    alignItems: "flex-end"
  }
});

// src/comp/ManeuverView/index.tsx
import { jsx as jsx7, jsxs as jsxs6 } from "react/jsx-runtime";
var ManeuverView = class extends Component8 {
  static defaultProps = {
    step: void 0,
    fontFamily: void 0,
    fontFamilyBold: void 0,
    backgroundColor: "#f7f7f4",
    fontSize: 20,
    arrowSize: 50,
    arrowColor: "#545455",
    withCloseButton: false,
    onClose: void 0,
    onPress: void 0
  };
  constructor(props) {
    super(props);
  }
  render() {
    const styles = styles_default6(this.props);
    const step = this.props.step;
    if (!step) return null;
    const maneuver = step.maneuver;
    return /* @__PURE__ */ jsxs6(TouchableOpacity3, { style: styles.maneuverView, onPress: this.props.onPress, children: [
      /* @__PURE__ */ jsx7(View5, { style: styles.maneuverViewArrow, children: /* @__PURE__ */ jsx7(
        ManeuverArrow,
        {
          size: this.props.arrowSize,
          color: this.props.arrowColor,
          maneuver
        }
      ) }),
      /* @__PURE__ */ jsx7(View5, { style: styles.maneuverViewDirection, children: /* @__PURE__ */ jsx7(
        ManeuverLabel,
        {
          ...this.props,
          instructions: step.instructions,
          fontSize: this.props.fontSize,
          fontColor: this.props.fontColor
        }
      ) }),
      !this.props.withCloseButton ? null : /* @__PURE__ */ jsx7(View5, { style: styles.maneuverClose, children: /* @__PURE__ */ jsx7(CloseButton, { onPress: () => this.props.onClose && this.props.onClose() }) })
    ] });
  }
};

// src/comp/MapViewNavigation/index.tsx
import { Component as Component12 } from "react";
import { Dimensions } from "react-native";
import geolocation from "@react-native-community/geolocation";

// src/mode/Tools.ts
import * as GeoLib from "geolib";
var toQueryParams = (object) => {
  return Object.keys(object).filter((key) => !!object[key]).map((key) => `${key}=${encodeURIComponent(object[key])}`).join("&");
};
var toLatLng = (value) => {
  if (typeof value === "string") return value;
  return value && value.latitude !== void 0 && value.longitude !== void 0 ? `${value.latitude},${value.longitude}` : value;
};
var toCoordinate = (latlng) => {
  const { lat, lng } = latlng;
  return { latitude: lat, longitude: lng };
};
var toNameId = (str, prepend = "", append = "") => {
  str = str.toLowerCase().replace(/_/g, " ").replace(/\b[a-z]/g, (letter) => letter.toUpperCase()).replace(/\s/g, "");
  return prepend + str + append;
};

// src/mode/Geocoder.ts
var AddressComponentMapping = {
  "street_number": "number",
  "route": "street",
  "postal_code": "zip",
  "country": "country",
  "locality": "city",
  "administrative_area_level_1": "state",
  "administrative_area_level_2": "county"
};
var Geocoder = class {
  apiKey;
  options;
  constructor(apiKey, options = {}) {
    this.apiKey = apiKey;
    this.options = options;
  }
  async getFromLocation(...params) {
    const queryParams = params.length === 1 && typeof params[0] === "string" ? { address: params[0] } : params;
    if (!params) {
      return Promise.reject("Not enough parameters");
    }
    queryParams.key = this.apiKey;
    if (this.options.language) {
      queryParams.language = this.options.language;
    }
    const url = `https://maps.google.com/maps/api/geocode/json?${toQueryParams(queryParams)}`;
    let response;
    let data;
    try {
      response = await fetch(url);
      data = await response.json();
    } catch (error) {
      return Promise.reject(error);
    }
    if (data.status !== "OK") {
      return Promise.reject(data);
    }
    return data.results;
  }
  getFromLatLng(lat, lng) {
    return this.getFromLocation({ latlng: `${lat},${lng}` });
  }
  minimizeResults(results) {
    if (!Array.isArray(results)) return [];
    return results.map((result) => {
      const { lat, lng } = result.geometry.location;
      return {
        components: this.minimizeAddressComponents(result.address_components),
        address: result.formatted_address,
        coordinate: {
          latitude: lat,
          longitude: lng
        }
      };
    });
  }
  minimizeAddressComponents(components) {
    const results = {};
    const ids = Object.keys(AddressComponentMapping);
    components.forEach((component) => {
      const index = ids.indexOf(component.types[0]);
      if (index !== -1) {
        results[AddressComponentMapping[ids[index]]] = {
          short: component.short_name,
          long: component.long_name
        };
      }
    });
    return results;
  }
};

// src/const/MarkerTypes.ts
var ORIGIN = "ORIGIN";
var DESTINATION = "DESTINATION";
var POSITION_DOT = "POSITION_DOT";
var POSITION_ARROW = "POSITION_ARROW";

// src/const/PolylineTypes.ts
var ROUTE = "ROUTE";
var ROUTE_ALTERNATIVE = "ROUTE_ALTERNATIVE";

// src/mode/Directions.ts
import * as GeoLib2 from "geolib";
var Directions = class {
  apiKey;
  options;
  constructor(apiKey, options = {}) {
    this.apiKey = apiKey;
    this.options = options;
  }
  fetch(origin, destination, options = {}) {
    options = {
      key: this.apiKey,
      mode: TravelModes_default.DRIVING,
      ...this.options,
      ...options
    };
    const queryParams = {
      origin: toLatLng(origin),
      destination: toLatLng(destination),
      ...options
    };
    if (queryParams.mode) queryParams.mode = queryParams.mode.toLowerCase();
    const url = `https://maps.google.com/maps/api/directions/json?${toQueryParams(queryParams)}`;
    return fetch(url).then((response) => response.json()).then((json) => {
      if (json.status !== "OK") {
        const errorMessage = json.error_message || "Unknown error";
        return Promise.reject(errorMessage);
      }
      return this.parse(json);
    });
  }
  parse(json) {
    if (!json.routes.length) return [];
    return json.routes.map((route) => {
      if (!route.legs.length) return null;
      const leg = route.legs[0];
      const markers = [
        {
          coordinate: toCoordinate(leg.start_location),
          type: ORIGIN
        },
        {
          coordinate: toCoordinate(leg.end_location),
          type: DESTINATION
        }
      ];
      const steps = leg.steps.map(
        (step, index) => this.parseStep(
          step,
          leg.steps[index + 1] ? leg.steps[index + 1] : void 0
        )
      );
      steps.push({
        final: true,
        bearing: steps[steps.length - 1].bearing,
        compass: steps[steps.length - 1].compass,
        start: steps[steps.length - 1].end,
        end: void 0,
        maneuver: {
          name: "flag",
          type: "flag"
        },
        polyline: {
          coordinates: [],
          type: ROUTE
        },
        instructions: leg.end_address,
        distance: steps[steps.length - 1].distance,
        duration: steps[steps.length - 1].duration,
        mode: ""
      });
      const polylines = steps.map((step) => step.polyline);
      console.log(polylines, "PACKAGE >>>>>> POLYLINES <<<<<<<");
      console.log(route, "PACKAGE >>>>>> ROUTE <<<<<<<");
      const getAllCoordinates = (polylines2) => {
        return polylines2.reduce(
          (acc, polyline) => {
            return acc.concat(polyline.coordinates);
          },
          []
        );
      };
      const boundingBox = [toCoordinate(route.bounds.northeast), toCoordinate(route.bounds.southwest)];
      return {
        title: route.summary,
        markers,
        steps,
        totalCoordinates: getAllCoordinates(polylines),
        polylines,
        bounds: {
          boundingBox,
          center: GeoLib2.getCenter(boundingBox),
          northEast: toCoordinate(route.bounds.northeast),
          southWest: toCoordinate(route.bounds.southwest)
        },
        initialBearing: steps.length ? steps[0].bearing : 0,
        duration: leg.duration,
        distance: leg.distance,
        origin: {
          address: leg.start_address,
          latlng: leg.start_location,
          coordinate: toCoordinate(leg.start_location)
        },
        destination: {
          address: leg.end_address,
          latlng: leg.end_location,
          coordinate: toCoordinate(leg.end_location)
        }
      };
    });
  }
  parseStep(step, nextStep) {
    const bearing = GeoLib2.getGreatCircleBearing(
      toCoordinate(step.start_location),
      toCoordinate(nextStep ? nextStep.start_location : step.end_location)
    );
    return {
      compass: this.decodeCompass(bearing),
      maneuver: this.decodeManeuver(step, bearing),
      bearing,
      mode: step.travel_mode,
      start: toCoordinate(step.start_location),
      end: toCoordinate(step.end_location),
      polyline: {
        coordinates: this.decodePolylineToCoordinates(step.polyline.points),
        type: ROUTE
      },
      duration: step.duration,
      distance: step.distance,
      instructions: step.html_instructions
    };
  }
  decodeManeuver(step, bearing) {
    const maneuver = step.maneuver || DEFAULT_DIRECTION_TYPE;
    const name = maneuver.split("-").map((d, i) => i === 0 ? d : d[0].toUpperCase() + d.slice(1)).join("");
    return {
      name,
      type: maneuver
    };
  }
  decodeCompass(bearing) {
    if (bearing < 0) return { detail: "", simple: "" };
    const compass = [
      DirectionTypes_default.NORTH,
      DirectionTypes_default.NORTHEAST,
      DirectionTypes_default.EAST,
      DirectionTypes_default.SOUTHEAST,
      DirectionTypes_default.SOUTH,
      DirectionTypes_default.SOUTHWEST,
      DirectionTypes_default.WEST,
      DirectionTypes_default.NORTHWEST
    ];
    const compassSimple = [
      DirectionTypes_default.NORTH,
      DirectionTypes_default.EAST,
      DirectionTypes_default.SOUTH,
      DirectionTypes_default.WEST
    ];
    const calc = (a) => {
      const c = Math.ceil(bearing / (360 / a.length)) - 1;
      return a[c < 0 ? 0 : c > a.length - 1 ? a.length - 1 : c];
    };
    return {
      detail: calc(compass),
      simple: calc(compassSimple)
    };
  }
  decodePolylineToCoordinates(t, e = 5) {
    const d = [];
    let n = 0, o = 0, u = 0, l = 0, r = 0, h = 0, i = 0, a = null;
    const c = Math.pow(10, e);
    for (let uIdx = 0; uIdx < t.length; ) {
      a = null;
      h = 0;
      i = 0;
      do {
        a = t.charCodeAt(uIdx++) - 63;
        i |= (31 & a) << h;
        h += 5;
      } while (a >= 32);
      n = 1 & i ? ~(i >> 1) : i >> 1;
      h = i = 0;
      do {
        a = t.charCodeAt(uIdx++) - 63;
        i |= (31 & a) << h;
        h += 5;
      } while (a >= 32);
      o = 1 & i ? ~(i >> 1) : i >> 1;
      l += n;
      r += o;
      d.push({ latitude: l / c, longitude: r / c });
    }
    return d;
  }
};

// src/const/NavigationModes.ts
var NavigationModes_default = {
  IDLE: "IDLE",
  ROUTE: "ROUTE",
  NAVIGATION: "NAVIGATION"
};

// src/mode/Simulator.ts
import * as GeoLib3 from "geolib";
var Simulator = class {
  instance;
  speed;
  turnSpeed;
  points;
  pointIndex;
  lastBearing;
  constructor(instance) {
    this.instance = instance;
    this.speed = 30;
    this.turnSpeed = 700;
    this.points = [];
    this.pointIndex = 0;
  }
  start(route) {
    this.pointIndex = 0;
    const steps = route.steps;
    const points = [];
    const result = [];
    steps.forEach((step) => {
      step.polyline.coordinates.forEach((coordinate) => points.push({ ...coordinate }));
    });
    points.forEach((point, index) => {
      const nextPoint = points[index + 1];
      if (nextPoint && !nextPoint.final) {
        const distance = Math.round(GeoLib3.getDistance(point, nextPoint));
        const bearing = GeoLib3.getGreatCircleBearing(point, nextPoint);
        if (bearing !== 0) {
          if (distance > 1) {
            for (let x = 1; x < distance; x++) {
              result.push({ ...GeoLib3.computeDestinationPoint(point, x, bearing), bearing });
            }
          } else {
            result.push({ ...point, bearing });
          }
        }
      }
    });
    this.pointIndex = 0;
    this.points = result;
    this.lastBearing = void 0;
    this.drive();
  }
  drive() {
    const point = this.points[this.pointIndex];
    let speed = this.speed;
    if (point && point.bearing !== void 0) {
      let allowPositionUpdate = true;
      if (this.lastBearing !== void 0) {
        if (point.bearing > this.lastBearing - 10 && point.bearing < this.lastBearing + 10) {
          this.instance.updateBearing(point.bearing, this.turnSpeed);
        } else {
          allowPositionUpdate = false;
          speed = this.turnSpeed;
          this.instance.updateBearing(point.bearing, this.turnSpeed);
        }
        this.lastBearing = point.bearing;
      }
      if (allowPositionUpdate) {
        this.instance.setPosition({
          ...point,
          heading: point.bearing
        });
        this.pointIndex++;
      }
      setTimeout(() => this.drive(), speed);
    }
  }
};

// src/mode/Traps.ts
import * as GeoLib4 from "geolib";

// src/const/TrapTypes.ts
var OPTIONS = {
  SINGLE_FIRE: "SINGLE_FIRE",
  AUTO_EXPIRE: "AUTO_EXPIRE"
};
var EVENTS = {
  ENTERING: "ENTERING",
  ENTERING_ON_COURSE: "ENTERING_ON_COURSE",
  ENTERING_OFF_COURSE: "ENTERING_OFF_COURSE",
  INSIDE: "INSIDE",
  INSIDE_CENTER: "INSIDE_CENTER",
  LEAVING: "LEAVING",
  LEAVING_ON_COURSE: "LEAVING_ON_COURSE",
  LEAVING_OFF_COURSE: "LEAVING_OFF_COURSE"
};
var STATES = {
  OUTSIDE: "OUTSIDE",
  ENTERED: "ENTERED",
  INSIDE: "INSIDE",
  CENTER: "CENTER",
  LEAVING: "LEAVING",
  LEFT: "LEFT",
  EXPIRED: "EXPIRED"
};
var TYPES = {
  POLYGON: "POLYGON",
  CIRCLE: "CIRCLE",
  STEP: "STEP"
};
var TrapTypes_default = {
  Events: EVENTS,
  States: STATES,
  Types: TYPES,
  Options: OPTIONS
};

// src/mode/Traps.ts
var Traps = class {
  instance;
  traps;
  counter;
  constructor(instance) {
    this.instance = instance;
    this.traps = {};
    this.counter = 0;
  }
  execute({ coordinate, heading }) {
    this.__matches(coordinate, heading);
  }
  add(trap, callback) {
    this.counter++;
    const counter = this.counter;
    this.traps[counter] = {
      ...trap,
      index: counter,
      state: TrapTypes_default.States.OUTSIDE,
      callback
    };
    Object.keys(TrapTypes_default.States).forEach((state) => {
      this.traps[counter][toNameId(state, "is")] = () => this.traps[counter].state === state;
    });
    return this.traps[counter];
  }
  getArray() {
    return Object.keys(this.traps).map((id) => this.traps[+id]);
  }
  watchRadius(coordinate, radius, options, callback) {
    return this.add({
      type: TrapTypes_default.Types.CIRCLE,
      coordinate,
      radius,
      options
    }, callback);
  }
  watchStep(step, nextStep, options, callback) {
    options = {
      distance: 15,
      innerRadiusTolerance: 0.75,
      centerRadiusTolerance: 0.5,
      courseTolerance: 30,
      ...options
    };
    const distanceToNextPoint = options.distance || step.distance.value;
    const coordinate = step.start;
    return this.add({
      type: TrapTypes_default.Types.STEP,
      innerRadius: distanceToNextPoint * options.innerRadiusTolerance,
      centerRadius: distanceToNextPoint * options.centerRadiusTolerance,
      outerRadius: distanceToNextPoint,
      courseTolerance: options.courseTolerance,
      coordinate,
      step,
      nextStep
    }, callback);
  }
  nextState(trap, event, state) {
    this.traps[trap.index].state = state;
    trap.callback && trap.callback(trap, event, state);
  }
  __matches(coordinate, heading) {
    const traps = Object.keys(this.traps);
    return traps.map((index) => {
      const trap = this.traps[+index];
      if (trap.state !== TrapTypes_default.States.EXPIRED) {
        switch (trap.type) {
          case TrapTypes_default.Types.CIRCLE:
            if (GeoLib4.isPointWithinRadius(coordinate, trap.coordinate, trap.radius)) {
            }
            break;
          case TrapTypes_default.Types.STEP:
            const insideOuter = GeoLib4.isPointWithinRadius(coordinate, trap.coordinate, trap.outerRadius);
            const insideInner = GeoLib4.isPointWithinRadius(coordinate, trap.coordinate, trap.innerRadius);
            const stateMap = {
              [TrapTypes_default.States.OUTSIDE]: [TrapTypes_default.States.ENTERED, () => {
                var _a;
                const isWithinCourse = this.isWithinCourse((_a = trap.step) == null ? void 0 : _a.bearing, heading, trap.courseTolerance);
                return insideOuter ? isWithinCourse ? TrapTypes_default.Events.ENTERING_ON_COURSE : TrapTypes_default.Events.ENTERING_OFF_COURSE : false;
              }],
              [TrapTypes_default.States.ENTERED]: [TrapTypes_default.States.INSIDE, () => {
                return insideOuter ? TrapTypes_default.Events.INSIDE : false;
              }],
              [TrapTypes_default.States.INSIDE]: [TrapTypes_default.States.CENTER, () => {
                return insideInner ? TrapTypes_default.Events.INSIDE_CENTER : false;
              }],
              [TrapTypes_default.States.CENTER]: [TrapTypes_default.States.LEAVING, () => {
                var _a;
                const isWithinCourse = this.isWithinCourse(trap.nextStep ? trap.nextStep.bearing : (_a = trap.step) == null ? void 0 : _a.bearing, heading, trap.courseTolerance);
                return insideOuter && !insideInner ? isWithinCourse ? TrapTypes_default.Events.LEAVING_ON_COURSE : TrapTypes_default.Events.LEAVING_OFF_COURSE : false;
              }],
              [TrapTypes_default.States.LEAVING]: [TrapTypes_default.States.LEFT, () => {
                return !insideOuter && !insideInner ? TrapTypes_default.Events.LEAVING : false;
              }],
              [TrapTypes_default.States.LEFT]: [TrapTypes_default.States.EXPIRED, () => {
                return true;
              }]
            };
            if (stateMap[trap.state]) {
              const [nextState, eventFunction] = stateMap[trap.state];
              const event = eventFunction();
              if (event) {
                this.nextState(trap, event, nextState);
                return true;
              }
            }
            break;
        }
      }
    });
  }
  isWithinCourse(bearing, heading, tolerance = 0) {
    const low = bearing - tolerance;
    const high = bearing + tolerance;
    return (low < 0 && heading > 360 - -1 * low || heading > low) && (high > 360 && heading < high - 360 || heading < high);
  }
};

// src/comp/RouteMarker/index.tsx
import { Component as Component9 } from "react";
import { Text as Text7 } from "react-native";
import { Marker } from "react-native-maps";

// src/theme/index.ts
var defaultThemeSettings = {
  Markers: {
    [ORIGIN]: {
      icon: NavigationIcons_default.place,
      color: "#77dd77",
      fontSize: 40
    },
    [DESTINATION]: {
      icon: NavigationIcons_default.place,
      color: "#ff4500",
      fontSize: 40
    },
    [POSITION_DOT]: {
      icon: NavigationIcons_default.compassDot,
      color: "#387bc1",
      fontSize: 30
    },
    [POSITION_ARROW]: {
      icon: NavigationIcons_default.navigate,
      size: 100,
      fontSize: 80,
      color: "#ffffff",
      backgroundColor: "#387bc1"
    }
  },
  Polylines: {
    [ROUTE]: {
      fillColor: "#00b3fd",
      strokeColor: "#387bc1",
      strokeWidth: 18,
      borderWidth: 4
    },
    [ROUTE_ALTERNATIVE]: {
      fillColor: "#cccccc",
      strokeColor: "#a0a0a0",
      strokeWidth: 18,
      borderWidth: 4
    }
  }
};
var connectTheme = (theme) => {
  return Object.assign({}, defaultThemeSettings, theme);
};
var theme_default = connectTheme;

// src/comp/RouteMarker/styles.ts
import { StyleSheet as StyleSheet9 } from "react-native";
var styles_default7 = (props) => StyleSheet9.create({
  markerText: {
    ...NavigationIconsFont,
    fontSize: props.fontSize || 30,
    color: props.color || "#000000"
  }
});

// src/comp/RouteMarker/index.tsx
import { jsx as jsx8 } from "react/jsx-runtime";
var RouterMarker = class extends Component9 {
  theme;
  constructor(props) {
    super(props);
    this.theme = theme_default(props.theme).Markers[props.type || "default"];
  }
  render() {
    const styles = styles_default7(this.theme);
    return /* @__PURE__ */ jsx8(Marker, { coordinate: this.props.coordinate, children: /* @__PURE__ */ jsx8(Text7, { style: styles.markerText, children: this.theme.icon }) }, this.props.key);
  }
};

// src/comp/RoutePolyline/index.tsx
import { Component as Component10 } from "react";
import { Polyline } from "react-native-maps";
import { Fragment, jsx as jsx9 } from "react/jsx-runtime";
var RoutePolyline = class extends Component10 {
  theme;
  constructor(props) {
    super(props);
    this.theme = theme_default(props.theme).Polylines[props.type || "default"];
  }
  render() {
    if (!this.props.coordinates) return null;
    if (!this.theme) {
      throw new Error(`RoutePolyline does not support type ${this.props.type}.`);
    }
    const components = [
      /* @__PURE__ */ jsx9(
        Polyline,
        {
          strokeWidth: this.theme.strokeWidth,
          strokeColor: this.theme.strokeColor,
          coordinates: this.props.coordinates,
          lineCap: "round"
        },
        0
      )
    ];
    if (this.theme.fillColor) {
      const borderWidth = this.theme.strokeWidth - (this.theme.borderWidth || 3);
      components.push(
        /* @__PURE__ */ jsx9(
          Polyline,
          {
            strokeWidth: borderWidth,
            strokeColor: this.theme.fillColor,
            coordinates: this.props.coordinates,
            lineCap: "round"
          },
          1
        )
      );
    }
    return /* @__PURE__ */ jsx9(Fragment, { children: components });
  }
};

// src/comp/PositionMarker/index.tsx
import { Component as Component11 } from "react";
import { Text as Text8, View as View6 } from "react-native";
import { Marker as Marker2 } from "react-native-maps";

// src/comp/PositionMarker/styles.ts
import { StyleSheet as StyleSheet10 } from "react-native";
var styles_default8 = (props) => StyleSheet10.create({
  positionMarkerText: {
    ...NavigationIconsFont,
    fontSize: props.fontSize,
    color: props.color
  },
  positionMarkerArrow: {
    backgroundColor: props.backgroundColor,
    width: props.size,
    height: props.size,
    borderRadius: props.size,
    justifyContent: "center",
    alignItems: "center",
    transform: [
      { rotateX: props.angle + "deg" }
    ]
  }
});

// src/comp/PositionMarker/index.tsx
import { jsx as jsx10 } from "react/jsx-runtime";
var defaultProps4 = {
  coordinate: void 0,
  size: 40,
  fontSize: 30,
  type: POSITION_DOT,
  color: "#252525",
  angle: 60,
  borderWidth: 0,
  borderColor: void 0,
  backgroundColor: "#252525"
};
var PositionMarker = class extends Component11 {
  static defaultProps = defaultProps4;
  theme;
  constructor(props) {
    super(props);
    this.theme = theme_default(this.props.theme).Markers[this.props.type || POSITION_DOT];
  }
  render() {
    const { coordinate, type } = this.props;
    if (!coordinate) return null;
    const styles = styles_default8({
      ...this.props,
      ...this.theme
    });
    return type === POSITION_ARROW ? this.renderArrow(styles) : this.renderDot(styles);
  }
  renderArrow(styles) {
    return /* @__PURE__ */ jsx10(
      Marker2,
      {
        coordinate: this.props.coordinate,
        flat: false,
        children: /* @__PURE__ */ jsx10(View6, { style: styles.positionMarkerArrow, children: /* @__PURE__ */ jsx10(Text8, { style: styles.positionMarkerText, children: this.theme.icon }) })
      }
    );
  }
  renderDot(styles) {
    return /* @__PURE__ */ jsx10(
      Marker2,
      {
        coordinate: this.props.coordinate,
        flat: false,
        children: /* @__PURE__ */ jsx10(Text8, { style: styles.positionMarkerText, children: this.theme.icon })
      }
    );
  }
};

// src/comp/MapViewNavigation/index.tsx
import { Circle, Polyline as Polyline2 } from "react-native-maps";
import { Fragment as Fragment2, jsx as jsx11, jsxs as jsxs7 } from "react/jsx-runtime";
var MapViewNavigation = class extends Component12 {
  static defaultProps = {
    origin: false,
    destination: false,
    apiKey: "",
    language: void 0,
    map: void 0,
    navigationMode: NavigationModes_default.IDLE,
    travelMode: TravelModes_default.DRIVING,
    maxZoom: 21,
    minZoom: 5,
    animationDuration: 750,
    navigationViewingAngle: 60,
    navigationZoomLevel: 14,
    directionZoomQuantifier: 1.5,
    onRouteChange: void 0,
    onStepChange: void 0,
    onNavigationStarted: void 0,
    onNavigationCompleted: void 0,
    routeStepDistance: 15,
    routeStepInnerTolerance: 0.75,
    routeStepCenterTolerance: 0.1,
    routeStepCourseTolerance: 30,
    displayDebugMarkers: false,
    simulate: false,
    onPositionChanged: void 0,
    options: {},
    deviceDimensionWidth: false,
    theme: void 0
  };
  geoCoder;
  directionsCoder;
  traps;
  simulator;
  aspectRatio;
  stepIndex = 0;
  watchId;
  theme;
  constructor(props) {
    super(props);
    this.geoCoder = new Geocoder(this.props.apiKey, { language: this.props.language });
    this.directionsCoder = new Directions(this.props.apiKey, { language: this.props.language });
    this.traps = new Traps(this);
    const { width, height } = Dimensions.get("window");
    this.aspectRatio = width / height;
    this.state = {
      route: false,
      markers: [],
      position: {},
      navigationMode: NavigationModes_default.IDLE,
      travelMode: TravelModes_default.DRIVING,
      stepIndex: false
    };
    this.theme = theme_default(this.props.theme);
  }
  componentDidMount() {
    this.watchId = geolocation.watchPosition((position) => {
      this.setPosition(position.coords);
    });
  }
  componentWillUnmount() {
    if (this.watchId) {
      geolocation.clearWatch(this.watchId);
    }
  }
  componentDidUpdate(prevProps, prevState) {
    if (this.props.origin && this.props.destination) {
      if (prevProps.navigationMode !== this.props.navigationMode || prevProps.travelMode !== this.props.travelMode || prevProps.origin !== this.props.origin || prevProps.destination !== this.props.destination) {
        this.updateRoute();
      }
    }
  }
  getCoordinates(address, raw = false) {
    return this.geoCoder.getFromLocation(address).then((results) => {
      const coordinates = raw ? results : this.geoCoder.minimizeResults(results);
      return coordinates.length === 1 ? coordinates[0] : coordinates;
    });
  }
  getZoomValue(level) {
    const value = 1e-5 * (this.props.maxZoom - (level < this.props.minZoom ? this.props.minZoom : level));
    return {
      latitudeDelta: value,
      longitudeDelta: value * this.aspectRatio
    };
  }
  getBoundingBoxZoomValue(b, quantifier = 1) {
    if (b.length !== 2) return {};
    const latitudeDelta = (b[0].latitude > b[1].latitude ? b[0].latitude - b[1].latitude : b[1].latitude - b[0].latitude) * quantifier;
    return {
      latitudeDelta,
      longitudeDelta: latitudeDelta * this.aspectRatio
    };
  }
  updateBearing(bearing, lon, lat, duration = this.props.animationDuration) {
    const newCamera = {
      center: {
        latitude: lat,
        longitude: lon
      },
      zoom: 30,
      heading: bearing,
      pitch: 80,
      altitude: 5
    };
    this.props.map().animateCamera(newCamera, { duration });
  }
  updateStep(stepIndex = 0) {
    var _a, _b;
    const step = (_a = this.state.route) == null ? void 0 : _a.steps[stepIndex < 0 ? 0 : stepIndex];
    const nextStep = (_b = this.state.route) == null ? void 0 : _b.steps[stepIndex + 1];
    this.props.onStepChange && this.props.onStepChange(step, nextStep);
    this.traps.watchStep(step, nextStep, {
      distance: this.props.routeStepDistance,
      innerRadiusTolerance: this.props.routeStepInnerTolerance,
      centerRadiusTolerance: this.props.routeStepCenterTolerance,
      courseTolerance: this.props.routeStepCourseTolerance
    }, (trap, event, state) => {
      if (!nextStep && trap.isCenter()) {
        this.props.onNavigationCompleted && this.props.onNavigationCompleted();
        this.setState({ navigationMode: NavigationModes_default.IDLE, stepIndex: false });
        return;
      }
      if (trap.isLeaving()) {
        this.updateStep(this.stepIndex);
      }
    });
    this.stepIndex = stepIndex + 1;
  }
  setPosition(position) {
    const { latitude, longitude, heading } = position;
    this.traps.execute({ heading, coordinate: { longitude, latitude } });
    if (this.state.navigationMode === NavigationModes_default.NAVIGATION) {
      this.updateBearing(heading, longitude, latitude);
      this.props.onPositionChanged && this.props.onPositionChanged({ longitude, latitude });
    }
    this.setState({ position });
  }
  clearRoute() {
    this.setState({ route: false, step: false, stepIndex: false });
  }
  updateRoute(origin = "", destination = "", navigationMode, options = null) {
    origin = origin || this.props.origin;
    destination = destination || this.props.destination;
    navigationMode = navigationMode || this.props.navigationMode;
    options = options || this.props.options;
    switch (navigationMode) {
      case NavigationModes_default.ROUTE:
        this.displayRoute(origin, destination, options);
        break;
      case NavigationModes_default.NAVIGATION:
        this.navigateRoute(origin, destination, options);
        break;
    }
  }
  prepareRoute(origin, destination, options = {}, testForRoute = false) {
    if (testForRoute && this.state.route) {
      return Promise.resolve(this.state.route);
    }
    options = Object.assign({}, { mode: this.state.travelMode }, { mode: this.props.travelMode }, options);
    return this.directionsCoder.fetch(origin, destination, options).then((routes) => {
      if (routes.length) {
        const route = routes[0];
        this.props.onRouteChange && this.props.onRouteChange(route);
        return route;
      }
      return Promise.reject(new Error("No route found"));
    });
  }
  displayRoute(origin, destination, options = {}) {
    this.prepareRoute(origin, destination, options).then((route) => {
      const region = {
        ...route.origin.coordinate,
        ...this.getBoundingBoxZoomValue([route.origin.coordinate, route.destination.coordinate], this.props.directionZoomQuantifier)
      };
      this.props.map().animateToRegion(region, this.props.animationDuration);
      this.setState({ route, navigationMode: NavigationModes_default.ROUTE });
    }).catch((error) => {
      console.error("Error displaying route:", error);
    });
  }
  navigateRoute(origin, destination, options = {}) {
    return this.prepareRoute(origin, destination, options, true).then((route) => {
      const region = {
        ...route.origin.coordinate,
        ...this.getZoomValue(this.props.navigationZoomLevel)
      };
      this.props.map().animateToRegion(region, this.props.animationDuration);
      this.updateBearing(route.initialBearing, route.origin.coordinate.longitude, route.origin.coordinate.latitude);
      this.setState({ navigationMode: NavigationModes_default.NAVIGATION });
      this.updateStep(0);
      this.props.onNavigationStarted && this.props.onNavigationStarted();
      if (this.props.simulate) {
        this.simulator = new Simulator(this);
        setTimeout(() => this.simulator.start(route), this.props.animationDuration * 1.5);
      } else {
        console.log("Simulation is disabled.");
      }
      return route;
    }).catch((error) => {
      console.error("Failed to navigate route:", error);
    });
  }
  getDebugShapes() {
    const shapes = [];
    if (this.state.route) {
      shapes.push(
        ...this.state.route.steps.map((step, index) => /* @__PURE__ */ jsx11(
          Circle,
          {
            center: step.coordinate,
            radius: 100,
            strokeColor: "#ff0000",
            fillColor: "rgba(255,0,0,0.1)"
          },
          `step-${index}`
        ))
      );
      shapes.push(
        ...this.state.route.steps.map((step, index) => /* @__PURE__ */ jsx11(
          Polyline2,
          {
            coordinates: [step.coordinate, step.nextStep ? step.nextStep.coordinate : step.coordinate],
            strokeColor: "#00ff00",
            strokeWidth: 2
          },
          `polyline-${index}`
        ))
      );
    }
    return shapes;
  }
  render() {
    const { displayDebugMarkers } = this.props;
    const { route, position, navigationMode } = this.state;
    return /* @__PURE__ */ jsxs7(Fragment2, { children: [
      navigationMode === NavigationModes_default.NAVIGATION && position.coordinate && /* @__PURE__ */ jsx11(PositionMarker, { coordinate: position.coordinate }),
      route && route.steps && route.steps.map((step, index) => /* @__PURE__ */ jsx11(
        RouterMarker,
        {
          coordinate: step.coordinate
        },
        `marker-${index}`
      )),
      route && /* @__PURE__ */ jsx11(
        RoutePolyline,
        {
          coordinates: route.steps.map((step) => step.coordinate)
        }
      ),
      displayDebugMarkers && this.getDebugShapes()
    ] });
  }
};

// src/comp/TravelModeBox/index.tsx
import { Component as Component13 } from "react";
import OptionGroupBox from "react-native-optiongroup";
import { jsx as jsx12 } from "react/jsx-runtime";
var TravelModeBox = class extends Component13 {
  static defaultProps = {
    backgroundColor: "transparent",
    borderColor: "#FFFFFF",
    borderWidth: 1,
    borderRadius: 3,
    contentPadding: 10,
    inverseTextColor: "#FFFFFF",
    defaultValue: DRIVING,
    selected: void 0,
    style: {},
    onChange: void 0,
    theme: void 0,
    invertKeyLabel: false,
    fontSize: 25,
    fontFamily: void 0,
    useIcons: true,
    modes: DEFAULT_MODES
  };
  constructor(props) {
    super(props);
  }
  render() {
    var _a;
    const options = (_a = this.props.modes) == null ? void 0 : _a.map((mode) => {
      return MODE_MAPPING[mode] || null;
    }).filter((option) => option !== null);
    return /* @__PURE__ */ jsx12(
      OptionGroupBox,
      {
        ...this.props,
        fontFamily: this.props.useIcons ? NavigationIconsFont.fontFamily : this.props.fontFamily,
        options,
        useKeyValue: "mode",
        useLabelValue: "icon"
      }
    );
  }
};

// src/comp/TravelModeLabel/index.tsx
import { Component as Component14 } from "react";
import { Text as Text9, View as View7 } from "react-native";

// src/comp/TravelModeLabel/styles.ts
import { StyleSheet as StyleSheet11 } from "react-native";
var styles_default9 = (props) => StyleSheet11.create({
  travelModeLabelContainer: {
    flexDirection: "row"
  },
  travelModeLabelIcon: {
    ...NavigationIconsFont,
    fontSize: props.size,
    opacity: props.opacity
  },
  travelModeLabelText: {
    fontFamily: props.fontFamily,
    fontSize: props.fontSize,
    opacity: props.opacity,
    flexWrap: "wrap"
  }
});

// src/comp/TravelModeLabel/index.tsx
import { jsx as jsx13, jsxs as jsxs8 } from "react/jsx-runtime";
var TravelModeLabel = class extends Component14 {
  static defaultProps = {
    color: void 0,
    opacity: 0.8,
    fontSize: 25,
    fontFamily: void 0,
    useIcon: true,
    useLabel: true,
    mode: void 0
  };
  constructor(props) {
    super(props);
  }
  render() {
    const styles = styles_default9(this.props);
    const travelMode = MODE_MAPPING[this.props.mode];
    if (!travelMode) return null;
    return /* @__PURE__ */ jsxs8(View7, { style: styles.travelModeLabelContainer, children: [
      this.props.useIcon && /* @__PURE__ */ jsx13(Text9, { style: styles.travelModeLabelIcon, children: travelMode.icon }),
      this.props.useLabel && /* @__PURE__ */ jsx13(Text9, { style: styles.travelModeLabelText, children: travelMode.name })
    ] });
  }
};
export {
  CloseButton,
  DirectionsListView as DirectionListViewItem,
  DirectionsListView,
  DurationDistanceLabel,
  DurationDistanceView,
  ManeuverArrow,
  ManeuverLabel,
  ManeuverView,
  MapViewNavigation,
  PositionMarker,
  RouterMarker as RouteMarker,
  RoutePolyline,
  TravelModeBox,
  TravelModeLabel
};
//# sourceMappingURL=index.mjs.map